

#include "stc15f2k60s2.h"
#include "vs1053.h"	
#include "delay.h"
#include "spi.h"
 	    



//VS10XXĬò
_vs10xx_obj vsset=
{
	220,	//:220
	6,		// 60Hz
	15,		// 15dB	
	10,		// 10Khz	
	15,		// 10.5dB
	0,		//ռЧ	
};


////////////////////////////////////////////////////////////////////////////////
//ֲʱĽӿ
//dat:Ҫд
//ֵ:
u8 VS_SPI_ReadWriteByte(u8 dat)
{			  	 
	return SPI_SendByte(dat);	  
}


//SPIߵ
void VS_SPI_SpeedLow(void)
{								 
	SPI_Speed(3);//õģʽ 
}


//SPI߸
void VS_SPI_SpeedHigh(void)
{						  
	SPI_Speed(0);//õģʽ		 
}



////////////////////////////////////////////////////////////////////////////////	 	  
//λVS1053
void VS_Soft_Reset(void)
{	 
	u8 retry=0;  				   
	while(VS_DQ==0); //ȴλ	   
	VS_SPI_ReadWriteByte(0Xff);//
	retry=0;
	while(VS_RD_Reg(SPI_MODE)!=0x0800)// λ,ģʽ  
	{
		VS_WR_Cmd(SPI_MODE,0x0804);// λ,ģʽ	λɹ λ10 ʱ˵λɹ    
		delay1ms(3);//ȴ1.35ms 
		if(retry++>100)break; 	    
	}	 		 
	while(VS_DQ==0);//ȴλ	 
	retry=0;
	while(VS_RD_Reg(SPI_CLOCKF)!=0X9800)//VS10XXʱ,3Ƶ ,1.5xADD 
	{
		VS_WR_Cmd(SPI_CLOCKF,0X9800);//VS10XXʱ,3Ƶ ,1.5xADD
		if(retry++>100)break; 	    
	}		    										    
	delay1ms(20);
} 



//ӲλMP3
//1:λʧ;0:λɹ	   
u8 VS_HD_Reset(void)
{
	u8 retry=0;
	VS_RST=0;
	delay1ms(20);
	VS_XDCS=1;//ȡݴ
	VS_XCS=1;//ȡݴ
	VS_RST=1;	   
	while(VS_DQ==0&&retry<200)//ȴDREQΪ
	{
		retry++;
		delay4us(13);
	};
	delay1ms(20);	
	if(retry>=200)return 1;
	else return 0;	    		 
}




//Ҳ 
void VS_Sine_Test(void)
{											    
	VS_HD_Reset();	 
	VS_WR_Cmd(0x0b,0X2020);	  //	 
 	VS_WR_Cmd(SPI_MODE,0x0820);//VS1053Ĳģʽ     
	while(VS_DQ==0);     //ȴDREQΪ
	//printf("mode sin:%x\n",VS_RD_Reg(SPI_MODE));
 	//VS10XXҲ0x53 0xef 0x6e n 0x00 0x00 0x00 0x00
 	//n = 0x24, 趨VS10XXҲƵֵ㷽VS10XXdatasheet
  	VS_SPI_SpeedLow();// 
	VS_XDCS=0;//ѡݴ
	VS_SPI_ReadWriteByte(0x53);
	VS_SPI_ReadWriteByte(0xef);
	VS_SPI_ReadWriteByte(0x6e);
	VS_SPI_ReadWriteByte(0x24);
	VS_SPI_ReadWriteByte(0x00);
	VS_SPI_ReadWriteByte(0x00);
	VS_SPI_ReadWriteByte(0x00);
	VS_SPI_ReadWriteByte(0x00);
	delay1ms(100);
	VS_XDCS=1; 
    //˳Ҳ
    VS_XDCS=0;//ѡݴ
	VS_SPI_ReadWriteByte(0x45);
	VS_SPI_ReadWriteByte(0x78);
	VS_SPI_ReadWriteByte(0x69);
	VS_SPI_ReadWriteByte(0x74);
	VS_SPI_ReadWriteByte(0x00);
	VS_SPI_ReadWriteByte(0x00);
	VS_SPI_ReadWriteByte(0x00);
	VS_SPI_ReadWriteByte(0x00);
	delay1ms(100);
	VS_XDCS=1;		 

    //ٴνҲԲnֵΪ0x44ҲƵΪֵ
    VS_XDCS=0;//ѡݴ      
	VS_SPI_ReadWriteByte(0x53);
	VS_SPI_ReadWriteByte(0xef);
	VS_SPI_ReadWriteByte(0x6e);
	VS_SPI_ReadWriteByte(0x44);
	VS_SPI_ReadWriteByte(0x00);
	VS_SPI_ReadWriteByte(0x00);
	VS_SPI_ReadWriteByte(0x00);
	VS_SPI_ReadWriteByte(0x00);
	delay1ms(100);
 	VS_XDCS=1;
    //˳Ҳ
    VS_XDCS=0;//ѡݴ
	VS_SPI_ReadWriteByte(0x45);
	VS_SPI_ReadWriteByte(0x78);
	VS_SPI_ReadWriteByte(0x69);
	VS_SPI_ReadWriteByte(0x74);
	VS_SPI_ReadWriteByte(0x00);
	VS_SPI_ReadWriteByte(0x00);
	VS_SPI_ReadWriteByte(0x00);
	VS_SPI_ReadWriteByte(0x00);
	delay1ms(100);
	VS_XDCS=1;	 
}	 


//ram  
//ֵ:RAMԽ
// VS1003õֵΪ0x807F;VS1053Ϊ0X83FF.																				 
u16 VS_Ram_Test(void)
{ 
	VS_HD_Reset();  
	
	   
 	VS_WR_Cmd(SPI_MODE,0x0820);// VS10XXĲģʽ
	while (VS_DQ==0); // ȴDREQΪ			   
	VS_SPI_SpeedLow();//
		 
	VS_XDCS=0;	       		    // xDCS = 1ѡVS10XXݽӿ
	VS_SPI_ReadWriteByte(0x4d);
	VS_SPI_ReadWriteByte(0xea);
	VS_SPI_ReadWriteByte(0x6d);
	VS_SPI_ReadWriteByte(0x54);
	VS_SPI_ReadWriteByte(0x00);
	VS_SPI_ReadWriteByte(0x00);
	VS_SPI_ReadWriteByte(0x00);
	VS_SPI_ReadWriteByte(0x00);
	delay1ms(200);  
	VS_XDCS=1;
	return VS_RD_Reg(SPI_HDAT0);// VS1003õֵΪ0x807F;VS1053Ϊ0X83FF.;       
}     	


				   
//VS10XXд
//address:ַ
//dat:
void VS_WR_Cmd(u8 address,u16 dat)
{  
	while(VS_DQ==0);//ȴ		  
	VS_SPI_SpeedLow();// 	   
	VS_XDCS=1; 	 
	VS_XCS=0; 	 
	VS_SPI_ReadWriteByte(VS_WRITE_COMMAND);//VS10XXд
	VS_SPI_ReadWriteByte(address); //ַ
	VS_SPI_ReadWriteByte(dat>>8); //͸߰λ
	VS_SPI_ReadWriteByte(dat);	 //ڰλ
	VS_XCS=1;           
	VS_SPI_SpeedHigh();//	   
} 


//VS10XXд
//dat:Ҫд
void VS_WR_Data(u8 dat)
{
	VS_SPI_SpeedHigh();//,VS1003B,ֵܳ36.864/4Mhz
	VS_XDCS=0;   
	VS_SPI_ReadWriteByte(dat);
	VS_XDCS=1;      
}      
   

//VS10XXļĴ           
//addressĴַ
//ֵֵ
//עⲻҪñٶȡ,
u16 VS_RD_Reg(u8 address)
{ 
	u16 temp=0;    	 
    while(VS_DQ==0);//ǵȴ״̬ 		  
	VS_SPI_SpeedLow();// 			SPI
	VS_XDCS=1;       
	VS_XCS=0;        
	VS_SPI_ReadWriteByte(VS_READ_COMMAND);	//VS10XXĶ
	VS_SPI_ReadWriteByte(address);       	//ַ
	temp=VS_SPI_ReadWriteByte(0xff); 		//ȡֽ
	temp=temp<<8;
	temp+=VS_SPI_ReadWriteByte(0xff); 		//ȡֽ
	VS_XCS=1;     
	VS_SPI_SpeedHigh();//	  
   return temp; 
}  



//ȡVS1053RAM
//addrRAMַ
//ֵֵ
u16 VS_WRAM_Read(u16 addr) 
{ 
	u16 res;			   	  
 	VS_WR_Cmd(SPI_WRAMADDR, addr); 
	res=VS_RD_Reg(SPI_WRAM);  
 	return res;
} 


////òٶȣVS1053Ч 
////t:0,1,ٶ;2,2ٶ;3,3ٶ;4,4;Դ
//void VS_Set_Speed(u8 t)
//{
//	VS_WR_Cmd(SPI_WRAMADDR,0X1E04);	//ٶȿƵַ  
//	while(VS_DQ==0); 				//ȴ	   
//	VS_WR_Cmd(SPI_WRAM,t); 			//д벥ٶ
//}


//FOR WAV HEAD0 :0X7761 HEAD1:0X7665    
//FOR MIDI HEAD0 :other info HEAD1:0X4D54
//FOR WMA HEAD0 :data speed HEAD1:0X574D
//FOR MP3 HEAD0 :data speed HEAD1:ID
//Ԥֵ,ײIII
const u16 bitrate[2][16]=
{ 
{0,8,16,24,32,40,48,56,64,80,96,112,128,144,160,0}, 
{0,32,40,48,56,64,80,96,112,128,160,192,224,256,320,0}
};
//KbpsĴС
//ֵõ
u16 VS_Get_HeadInfo(void)
{
	unsigned int HEAD0;
	unsigned int HEAD1;  
 	HEAD0=VS_RD_Reg(SPI_HDAT0); 
    HEAD1=VS_RD_Reg(SPI_HDAT1);
  	//printf("(H0,H1):%x,%x\n",HEAD0,HEAD1);
    switch(HEAD1)
    {        
        case 0x7665://WAVʽ
        case 0X4D54://MIDIʽ 
		case 0X4154://AAC_ADTS
		case 0X4144://AAC_ADIF
		case 0X4D34://AAC_MP4/M4A
		case 0X4F67://OGG
        case 0X574D://WMAʽ
		case 0X664C://FLACʽ
        {
			////printf("HEAD0:%d\n",HEAD0);
            HEAD1=HEAD0*2/25;//൱*8/100
            if((HEAD1%10)>5)return HEAD1/10+1;//Сһλ
            else return HEAD1/10;
        }
        default://MP3ʽ,˽ײIIIı
        {
            HEAD1>>=3;
            HEAD1=HEAD1&0x03; 
            if(HEAD1==3)HEAD1=1;
            else HEAD1=0;
            return bitrate[HEAD1][HEAD0>>12];
        }
    }  
}
////õƽֽ
////ֵƽֽٶ
//u32 VS_Get_ByteRate(void)
//{
//	return VS_WRAM_Read(0X1E05);//ƽλ
//}

//õҪ
//ֵ:Ҫ
u16 VS_Get_EndFillByte(void)
{
	return VS_WRAM_Read(0X1E06);//ֽ
}  

//һƵ
//̶Ϊ32ֽ
//ֵ:0,ͳɹ
//		 1,VS10xxȱ,δɹ    
u8 VS_Send_MusicData(u8* buf)
{
	u8 n;
	if(VS_DQ!=0)  //ݸVS10XX
	{			   	 
		VS_XDCS=0;  
        for(n=0;n<32;n++)
		{
			VS_SPI_ReadWriteByte(buf[n]);	 			
		}
		VS_XDCS=1;     				   
	}else return 1;
	return 0;//ɹ
}


//и
//ͨ˺и裬л
//ҪĿȡǰ  ȡܴﵽһνиЧ				
void VS_Restart_Play(void)
{
	u16 temp;
	u16 i;
	u8 n;	  
	u8 vsbuf[32];

	for(n=0;n<32;n++)vsbuf[n]=0;//

	temp=VS_RD_Reg(SPI_MODE);	//ȡSPI_MODE
	temp|=1<<3;					//SM_CANCELλ
	temp|=1<<2;					//SM_LAYER12λ,MP1,MP2
	VS_WR_Cmd(SPI_MODE,temp);	//ȡǰָ

	for(i=0;i<2048;)			//20480,ڼȡSM_CANCELλ.Ϊ0,ʾѾȡ˵ǰ
	{
		if(VS_Send_MusicData(vsbuf)==0)//ÿ32ֽںһ
		{
			i+=32;						//32ֽ
   			temp=VS_RD_Reg(SPI_MODE);	//ȡSPI_MODE
 			if((temp&(1<<3))==0)break;	//ɹȡ
		}	
	}

	if(i<2048)//SM_CANCEL
	{
		temp=VS_Get_EndFillByte()&0xff;//ȡֽ
		for(n=0;n<32;n++)vsbuf[n]=temp;//ֽڷ
		for(i=0;i<2052;)
		{
			if(VS_Send_MusicData(vsbuf)==0)i+=32;//	  
		}   	
	}else VS_Soft_Reset();  	//SM_CANCELɹ,,Ҫλ 
		  
	temp=VS_RD_Reg(SPI_HDAT0); 
    temp+=VS_RD_Reg(SPI_HDAT1);

	if(temp)					//λ,ûгɹȡ,ɱ,Ӳλ
	{
		VS_HD_Reset();		   	//Ӳλ
		VS_Soft_Reset();  		//λ 
	} 
}


//ʱ                          
void VS_Reset_DecodeTime(void)
{
	VS_WR_Cmd(SPI_DECODE_TIME,0x0000);
	VS_WR_Cmd(SPI_DECODE_TIME,0x0000);//
}


//õmp3Ĳʱn sec
//ֵʱ
u16 VS_Get_DecodeTime(void)
{ 		
	u16 dt=0;	 
	dt=VS_RD_Reg(SPI_DECODE_TIME);      
 	return dt;
} 	    

					  
//vs10xxװpatch.
//patchpatch׵ַ
//lenpatch
void VS_Load_Patch(u16 *patch,u16 len) 
{
	u16 i; 
	u16 addr, n, val; 	  			   
	for(i=0;i<len;) 
	{ 
		addr = patch[i++]; 
		n    = patch[i++]; 
		if(n & 0x8000U) //RLE run, replicate n samples 
		{ 
			n  &= 0x7FFF; 
			val = patch[i++]; 
			while(n--)VS_WR_Cmd(addr, val);  
		}else //copy run, copy n sample 
		{ 
			while(n--) 
			{ 
				val = patch[i++]; 
				VS_WR_Cmd(addr, val); 
			} 
		} 
	} 	
} 		  	  





//
///////////////////////////////////////////////////////////////////////////////////////////// 
//Ƶʾ
#define SPEC_dat_BASE 	0X1810 	//0X1380 for VS1011
//õƵ
//*specbuf:Ƶݻ
//ֵ:Ƶ.
u8 VS_Get_Spec(u8 *p)
{
//	U8 bands;
	u8 i;
    u16 tmp;
	//VS_WR_Cmd(SPI_WRAMADDR,SPEC_dat_BASE+2);  
	//bands=VS_RD_Reg(SPI_WRAM);					//ȡƵ 
	VS_WR_Cmd(SPI_WRAMADDR,SPEC_dat_BASE+4);  //дȡƵ
	for (i=0;i<14;i++) 
	{  
		//ƵݷΪ2,ЧλΪ12λ.Χ0~31
		//[5:0]:ǰֵ
		//[11:6]:ֵ 
        tmp = VS_RD_Reg(SPI_WRAM);				//ȡǰֵͷֵ                                  
		*p++= (tmp&0x3f);						//ֻյǰֵ
 	} 
	return 14;
}


//趨µƵ	 
//buf:Ƶֵ
//bands:bufĴС.VS1053Ϊ15
void VS_Set_Bands(u16 *buf,u8 bands)
{
	u8 i;
	VS_WR_Cmd(SPI_WRAMADDR,SPEC_dat_BASE+0X58);//ַ1868,VS1053,SPEC_dat_BASE0X1810.Լ0X58  
	for (i=0;i<bands;i++) 
	{
		VS_WR_Cmd(SPI_WRAM,buf[i]);//Ƶ  
	}
	if(i<15)VS_WR_Cmd(SPI_WRAM,25000);//VS1053ֵΪ15,25000,ʾƵױ
 	VS_WR_Cmd(SPI_WRAMADDR,SPEC_dat_BASE+1);//ַSPEC_dat_BASE+1,ΪSamples Ratesʼַ
	VS_WR_Cmd(SPI_WRAM,0);	//ʼƵ
}








//趨VS10XXŵ͸ߵ
//volx:С(0~254)
void VS_Set_Vol(u8 volx)
{
    u16 volt=0; 			//ݴֵ
    volt=254-volx;			//ȡһ,õֵ,ʾıʾ 
	volt<<=8;
    volt+=254-volx;			//õúС
    VS_WR_Cmd(SPI_VOL,volt);// 
}


//趨ߵ
//bfreq:ƵƵ	2~15(λ:10Hz)
//bass:Ƶ			0~15(λ:1dB)
//tfreq:ƵƵ 	1~15(λ:Khz)
//treble:Ƶ  	 	0~15(λ:1.5dB,С9ʱΪ)
void VS_Set_Bass(u8 bfreq,u8 bass,u8 tfreq,u8 treble)
{
    u16 bass_set=0; //ݴĴֵ
    signed char temp=0;   	 
	if(treble==0)temp=0;	   		//任
	else if(treble>8)temp=treble-8;
 	else temp=treble-9;  
	bass_set=temp&0X0F;				//趨
	bass_set<<=4;
	bass_set+=tfreq&0xf;			//Ƶ
	bass_set<<=4;
	bass_set+=bass&0xf;				//趨
	bass_set<<=4;
	bass_set+=bfreq&0xf;			//    
	VS_WR_Cmd(SPI_BASS,bass_set);	//BASS 
}


//趨Ч
//eft:0,ر;1,С;2,е;3,.
void VS_Set_Effect(u8 eft)
{
	u16 temp;	 
	temp=VS_RD_Reg(SPI_MODE);	//ȡSPI_MODE
	if(eft&0X01)temp|=1<<4;		//趨LO
	else temp&=~(1<<5);			//ȡLO
	if(eft&0X02)temp|=1<<7;		//趨HO
	else temp&=~(1<<7);			//ȡHO						   
	VS_WR_Cmd(SPI_MODE,temp);	//趨ģʽ    
}	  


///////////////////////////////////////////////////////////////////////////////
//,Ч.
void VS_Set_All(void) 				
{			 
	VS_Set_Vol(vsset.mvol);
	VS_Set_Bass(vsset.bflimit,vsset.bass,vsset.tflimit,vsset.treble);  
	VS_Set_Effect(vsset.effect);
}
























